﻿using System;
using System.ComponentModel;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace BandedSpectrumAnalyzer
{
    /// <summary>
    /// Interaction logic for AlbumArtworkPanel.xaml
    /// </summary>
    public partial class AlbumArtworkPanel : UserControl
    {
        #region Dependency Property Declarations
        public static readonly DependencyProperty AlbumArtImageProperty =
            DependencyProperty.Register("AlbumArtImage",
            typeof(ImageSource),
            typeof(AlbumArtworkPanel));
        #endregion

        #region Dependency Properties
        public ImageSource AlbumArtImage
        {
            get { return (ImageSource)GetValue(AlbumArtImageProperty); }
            set
            {
                SetValue(AlbumArtImageProperty, value);
            }
        }
        #endregion

        public AlbumArtworkPanel()
        {
            InitializeComponent();

            DependencyPropertyDescriptor backgroundDescriptor = DependencyPropertyDescriptor.FromProperty(AlbumArtImageProperty, typeof(AlbumArtworkPanel));
            backgroundDescriptor.AddValueChanged(this, AlbumArtChanged);
        }

        private void AlbumArtChanged(object sender, EventArgs e)
        {
            AlbumArtImageBox.Source = AlbumArtImage;
            if (AlbumArtImage == null)
            {
                AlbumOverlayImage.Visibility = System.Windows.Visibility.Hidden;
                NoAlbumArtImage.Visibility = System.Windows.Visibility.Visible;
                AlbumArtImageBox.Visibility = System.Windows.Visibility.Hidden;                
            }
            else
            {
                AlbumOverlayImage.Visibility = System.Windows.Visibility.Visible;
                NoAlbumArtImage.Visibility = System.Windows.Visibility.Hidden;
                AlbumArtImageBox.Visibility = System.Windows.Visibility.Visible;                
            }
        }
    }
}
